unit ufunction;
{$mode objFPC}
{$goto on}

interface

{$if defined (Windows) or defined (Unix)}
uses
   SysUtils;

   function TtoS(T: TDateTime): String;
{$endif}

{$ifdef cpuavr}
function bool(value: Byte): boolean;
function BtC(Value: boolean): char;

procedure delay(value: int32);
procedure delay_1u_8;
procedure delay_500n_8;

procedure T0H;
procedure T0L;

procedure T1H;
procedure T1L;
{$endif}

implementation

{$if defined (Windows) or defined (Unix)}

function TtoS(T: TDateTime): String;
var
  h, m, s, ms: Word;
begin
  DecodeTime(T, h, m, s, ms);
  if h > 0 then
    Result                 := FormatDateTime('hh:nn:ss',T)
  else
    Result                 := FormatDateTime('nn:ss',T);
end;

{$endif}

{$ifdef CPUAVR}

procedure DeztoBin(aint, bits:integer);
var
  B:integer;
  puffer:integer;
  a: String;

begin
puffer := aint;
for B:= bits downto 0 do
    begin
    if puffer mod 2 = 0 then
       begin
       Puffer:= puffer div 2;
       a:= '0'+a;
       end
    else
        begin
        puffer:= Puffer div 2;
        a:='1'+a;
        end;
    end;
end;

// Change the bytes (0 | 1) to boolean values (False = 0 | True = 1)
function bool(value: Byte): boolean;
begin
  if value = 0 then result := False;
  if value = 1 then result := True;
end;

function BtC(Value: boolean): char;
begin
  if not value then result := '0';
  if     value then result := '1';
end;

// Zeitfunctionen
procedure delay(value: int32);
var
  i: int32;
begin
  for i := 1 to value do begin
    asm nop end;
    end;
end;

// Kurzes Delay (1µs bei 8 MHz)
procedure delay_1u_8;
label
  loop;
begin
  asm
    ldi r16, 60
    loop:
      dec r16
      brne loop
    end['r16'];
  end;

// Kurzes Delay (0.5µs bei 8 MHz)
procedure delay_500n_8;
label
  loop;
begin
  asm
    ldi r16, 30
    loop:
      dec r16
      brne loop
    end['r16'];
  end;


// Zeitfunctionen für die Ansteuerung eine Neo_Pixel-LED
// Die Zeiten sind im Datenblatt auf Seite 5 hinterlegt

// Erste Testfunktion erfolgt mit einem ATTiny85 und einem Takt von 8 Mhz

procedure T0H; //0,35µs +-150ns
label
  loop;
begin
  asm
  {$if defined (ATTiny85)}ldi r16, 21{$endif}
  {$if defined (ATMega16)}ldi r16, 42{$endif}
    loop:
      dec r16
      brne loop
    end['r16'];
  end;

procedure T0L; //0,9µS +-150ns
label
  loop;
begin
  asm
  {$if defined (ATTiny85)}ldi r16, 54{$endif}
  {$if defined (ATMega16)}ldi r16, 108{$endif}
    loop:
      dec r16
      brne loop
    end['r16'];
  end;

procedure T1H; //0,9µS +-150ns
label
  loop;
begin
  asm
  {$if defined (ATTiny85)}ldi r16, 54{$endif}
  {$if defined (ATMega16)}ldi r16, 108{$endif}
    loop:
      dec r16
      brne loop
    end['r16'];
  end;

procedure T1L; //0,35µs +-150ns
label
  loop;
begin
  asm
  {$if defined (ATTiny85)}ldi r16, 21{$endif}
  {$if defined (ATMega16)}ldi r16, 42{$endif}
    loop:
      dec r16
      brne loop
    end['r16'];
  end;

{$endif}

end.

